<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/Port.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('Port_8cpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Port.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Accessories&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Port&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Accessories_8h.html">Accessories.h</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifdef ARDUINO_ARCH_SAM</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keywordtype">void</span> Port::CheckPinNb(<span class="keywordtype">int</span> inPin, PIN_TYPE inType, <span class="keyword">const</span> <span class="keywordtype">char</span> *inFunc)</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="keywordtype">int</span> pin = inPin;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="keywordflow">if</span> (inType &lt; ANALOG)</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        pin = GPIO_to_Arduino_pin((GPIO_pin_t)inPin);</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keywordflow">if</span> (pin &lt;= 0 || pin &gt;= NUM_DIGITAL_PINS)</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    {</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keywordflow">if</span> (pin &lt; A0 || pin &gt; A7)</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        {</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;            Serial.print(F(<span class="stringliteral">&quot;Pin &quot;</span>));</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;            Serial.print(inPin);</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;            Serial.print(F(<span class="stringliteral">&quot; error in &quot;</span>));</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;            Serial.println(inFunc);</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        }</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    }</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;}</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keywordtype">void</span> Port::CheckPinNb(<span class="keywordtype">int</span> inPin, PIN_TYPE inType, <span class="keyword">const</span> __FlashStringHelper *inFunc)</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">int</span> pin = inPin;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordflow">if</span> (inType &lt; ANALOG)</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        pin = GPIO_to_Arduino_pin((GPIO_pin_t)inPin);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordflow">if</span> (pin &lt;= 0 || pin &gt;= NUM_DIGITAL_PINS)</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    {</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordflow">if</span> (pin &lt; A0 || pin &gt; A7)</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;            Serial.print(F(<span class="stringliteral">&quot;Pin &quot;</span>));</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            Serial.print(inPin);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            Serial.print(F(<span class="stringliteral">&quot; error in &quot;</span>));</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            Serial.println(inFunc);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        }</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;}</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classPort.html#a2cfb70a4b6d730e715042d646ec1d960">   49</a></span>&#160;<a class="code" href="classPort.html#a2cfb70a4b6d730e715042d646ec1d960">Port::Port</a>()</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    this-&gt;<a class="code" href="classPort.html#ad7ef0d65cab5721a7e2d9b2a71663eef">pinType</a> = DIGITAL;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    this-&gt;<a class="code" href="classPort.html#ad71ca654c312fdec59194e393411fce0">state</a> = PORT_STOP;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    this-&gt;<a class="code" href="classPort.html#a8a53f78f0221c753527a92cb9cb0f68f">speed</a> = DEFAULTSPEED;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;}</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="classPort.html#a87373fe4ced21a4bcc61a0d66153f754">   56</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="classPort.html#a87373fe4ced21a4bcc61a0d66153f754">Port::MapValue</a>(<span class="keywordtype">int</span> inValue, PIN_TYPE inType)<span class="keyword"> const</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordflow">if</span> (inType == UNDEFINED)</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        inType = this-&gt;<a class="code" href="classPort.html#ad7ef0d65cab5721a7e2d9b2a71663eef">pinType</a>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordflow">if</span> (inType == ANALOG_INVERTED)</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keywordflow">return</span> 255 - inValue;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordflow">if</span> (inType == DIGITAL_INVERTED)</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    {</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keywordflow">if</span> (inValue == LOW) </div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <span class="keywordflow">return</span> HIGH;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keywordflow">return</span> LOW;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    }</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordflow">return</span> inValue;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;}</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classPort.html#ad5c7ecf52b369e61dcc1353b81532bf5">   74</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="classPort.html#ad5c7ecf52b369e61dcc1353b81532bf5">Port::beginPin</a>(<span class="keywordtype">int</span> inPin, PIN_TYPE inType)<span class="keyword"> const</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">int</span> pin = -1;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordflow">if</span> (inType == UNDEFINED)</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        inType = this-&gt;<a class="code" href="classPort.html#ad7ef0d65cab5721a7e2d9b2a71663eef">pinType</a>;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordflow">if</span> (inType &lt; ANALOG)</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    {</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        pin = Arduino_to_GPIO_pin(inPin);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        pinMode2f((GPIO_pin_t)pin, OUTPUT);</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    }</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        pin = inPin;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <a class="code" href="classPort.html#a8d01bcb7d500d5bc3d18c7665123c942">MovePin</a>(pin, LOW, inType);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keywordflow">return</span> pin;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;}</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="classPort.html#a8d01bcb7d500d5bc3d18c7665123c942">   92</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classPort.html#a8d01bcb7d500d5bc3d18c7665123c942">Port::MovePin</a>(<span class="keywordtype">int</span> inPin, <span class="keywordtype">int</span> inValue, PIN_TYPE inType)<span class="keyword"> const</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordflow">if</span> (inType == UNDEFINED)</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        inType = this-&gt;<a class="code" href="classPort.html#ad7ef0d65cab5721a7e2d9b2a71663eef">pinType</a>;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    CHECKPIN(inPin, inType, <span class="stringliteral">&quot;Incorrect pin number in MovePin&quot;</span>);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordflow">if</span> (inType &lt; ANALOG)</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        digitalWrite2f((GPIO_pin_t)inPin, this-&gt;<a class="code" href="classPort.html#a87373fe4ced21a4bcc61a0d66153f754">MapValue</a>(inValue, inType));</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keywordflow">if</span> (inValue == HIGH)</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            analogWrite(inPin, this-&gt;<a class="code" href="classPort.html#a87373fe4ced21a4bcc61a0d66153f754">MapValue</a>(this-&gt;<a class="code" href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">GetSpeed</a>(), inType));</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            analogWrite(inPin, this-&gt;<a class="code" href="classPort.html#a87373fe4ced21a4bcc61a0d66153f754">MapValue</a>(0, inType));</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;}</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">  108</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">Port::SetSpeed</a>(<span class="keywordtype">int</span> inSpeed)</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;{</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    uint8_t oldSpeed = this-&gt;<a class="code" href="classPort.html#a8a53f78f0221c753527a92cb9cb0f68f">speed</a>;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    this-&gt;<a class="code" href="classPort.html#a8a53f78f0221c753527a92cb9cb0f68f">speed</a> = inSpeed;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordflow">return</span> oldSpeed;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;}</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="classPort.html#a2372de3e7c26ba23f5977658c71888b7">  115</a></span>&#160;PORT_STATE <a class="code" href="classPort.html#a2372de3e7c26ba23f5977658c71888b7">Port::MoveToggle</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inDuration)</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;{</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classPort.html#a365a8f66d81dd6a422868b1368845e23">IsLeftDir</a>())</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    {</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <a class="code" href="classPort.html#aab681b4f2e4bb26a31d80308a04e348f">MoveRightDir</a>(inDuration);</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    }</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    {</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <a class="code" href="classPort.html#aef667cb477268c60f098300e139530ba">MoveLeftDir</a>(inDuration);</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    }</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        </div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordflow">return</span> this-&gt;<a class="code" href="classPort.html#a56425e29545c1c169c7efd76e6bf411c">GetState</a>();</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;}</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="classPort.html#a8a6af50e48788eedf1a4a95122082643">  129</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classPort.html#aef667cb477268c60f098300e139530ba">Port::MoveLeftDir</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inDuration, <span class="keywordtype">int</span> inSpeed)</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;{</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordtype">int</span> oldSpeed = -1;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="keywordflow">if</span> (inSpeed &gt;= 0)</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        oldSpeed = this-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(inSpeed);</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    this-&gt;<a class="code" href="classPort.html#aef667cb477268c60f098300e139530ba">MoveLeftDir</a>(inDuration);</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <span class="keywordflow">if</span> (oldSpeed != -1)</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        this-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(oldSpeed);</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;}</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno"><a class="line" href="classPort.html#ac78e0a5b72fc16c1240cecb5d6fe2f7f">  139</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classPort.html#aab681b4f2e4bb26a31d80308a04e348f">Port::MoveRightDir</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inDuration, <span class="keywordtype">int</span> inSpeed)</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;{</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="keywordtype">int</span> oldSpeed = -1;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keywordflow">if</span> (inSpeed &gt;= 0)</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        oldSpeed = this-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(inSpeed);</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    this-&gt;<a class="code" href="classPort.html#aab681b4f2e4bb26a31d80308a04e348f">MoveRightDir</a>(inDuration);</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <span class="keywordflow">if</span> (oldSpeed != -1)</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        this-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(oldSpeed);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;}</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="keywordtype">void</span> Port::printPort()</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;{</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;}</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="keywordtype">void</span> Port::printPortPin(<span class="keywordtype">int</span> inPin, PIN_TYPE inType)</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;{</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    Serial.print(<span class="stringliteral">&quot; &quot;</span>);</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="keywordflow">if</span> (inType &lt; ANALOG)</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        Serial.print(GPIO_to_Arduino_pin((GPIO_pin_t)inPin));</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        Serial.print(inPin);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    Serial.print(<span class="stringliteral">&quot; (&quot;</span>);</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="keywordflow">switch</span> (inType)</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    {</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <span class="keywordflow">case</span> UNDEFINED:         Serial.print(<span class="stringliteral">&quot;UNDEFINED)&quot;</span>); <span class="keywordflow">break</span>;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    <span class="keywordflow">case</span> DIGITAL:           Serial.print(<span class="stringliteral">&quot;DIGITAL)&quot;</span>); <span class="keywordflow">break</span>;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <span class="keywordflow">case</span> DIGITAL_INVERTED:  Serial.print(<span class="stringliteral">&quot;DIGITAL_INVERTED)&quot;</span>); <span class="keywordflow">break</span>;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <span class="keywordflow">case</span> ANALOG:            Serial.print(<span class="stringliteral">&quot;ANALOG)&quot;</span>); <span class="keywordflow">break</span>;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="keywordflow">case</span> ANALOG_INVERTED:   Serial.print(<span class="stringliteral">&quot;ANALOG_INVERTED)&quot;</span>); <span class="keywordflow">break</span>;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    }</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;}</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classPort_html_a56425e29545c1c169c7efd76e6bf411c"><div class="ttname"><a href="classPort.html#a56425e29545c1c169c7efd76e6bf411c">Port::GetState</a></div><div class="ttdeci">PORT_STATE GetState() const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00114">Port.hpp:114</a></div></div>
<div class="ttc" id="classPort_html_aef667cb477268c60f098300e139530ba"><div class="ttname"><a href="classPort.html#aef667cb477268c60f098300e139530ba">Port::MoveLeftDir</a></div><div class="ttdeci">virtual void MoveLeftDir(unsigned long inDuration = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00143">Port.hpp:143</a></div></div>
<div class="ttc" id="classPort_html_aab681b4f2e4bb26a31d80308a04e348f"><div class="ttname"><a href="classPort.html#aab681b4f2e4bb26a31d80308a04e348f">Port::MoveRightDir</a></div><div class="ttdeci">virtual void MoveRightDir(unsigned long inDuration = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00147">Port.hpp:147</a></div></div>
<div class="ttc" id="classPort_html_a365a8f66d81dd6a422868b1368845e23"><div class="ttname"><a href="classPort.html#a365a8f66d81dd6a422868b1368845e23">Port::IsLeftDir</a></div><div class="ttdeci">bool IsLeftDir() const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00130">Port.hpp:130</a></div></div>
<div class="ttc" id="classPort_html_a2372de3e7c26ba23f5977658c71888b7"><div class="ttname"><a href="classPort.html#a2372de3e7c26ba23f5977658c71888b7">Port::MoveToggle</a></div><div class="ttdeci">PORT_STATE MoveToggle(unsigned long inDuration = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00115">Port.cpp:115</a></div></div>
<div class="ttc" id="classPort_html_a676359ed59bf5091126fd96e1a04cafa"><div class="ttname"><a href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">Port::SetSpeed</a></div><div class="ttdeci">virtual int SetSpeed(int inSpeed)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00108">Port.cpp:108</a></div></div>
<div class="ttc" id="classPort_html_aed93eb0b1e3fcb88843f6c5606d55621"><div class="ttname"><a href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">Port::GetSpeed</a></div><div class="ttdeci">int GetSpeed() const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00119">Port.hpp:119</a></div></div>
<div class="ttc" id="classPort_html_a8d01bcb7d500d5bc3d18c7665123c942"><div class="ttname"><a href="classPort.html#a8d01bcb7d500d5bc3d18c7665123c942">Port::MovePin</a></div><div class="ttdeci">void MovePin(int inPin, int inValue, PIN_TYPE inType = UNDEFINED) const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00092">Port.cpp:92</a></div></div>
<div class="ttc" id="classPort_html_ad5c7ecf52b369e61dcc1353b81532bf5"><div class="ttname"><a href="classPort.html#ad5c7ecf52b369e61dcc1353b81532bf5">Port::beginPin</a></div><div class="ttdeci">int beginPin(int inPin, PIN_TYPE inType = UNDEFINED) const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00074">Port.cpp:74</a></div></div>
<div class="ttc" id="classPort_html_a87373fe4ced21a4bcc61a0d66153f754"><div class="ttname"><a href="classPort.html#a87373fe4ced21a4bcc61a0d66153f754">Port::MapValue</a></div><div class="ttdeci">int MapValue(int inValue, PIN_TYPE inType = UNDEFINED) const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00056">Port.cpp:56</a></div></div>
<div class="ttc" id="classPort_html_a8a53f78f0221c753527a92cb9cb0f68f"><div class="ttname"><a href="classPort.html#a8a53f78f0221c753527a92cb9cb0f68f">Port::speed</a></div><div class="ttdeci">int speed</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00069">Port.hpp:69</a></div></div>
<div class="ttc" id="classPort_html_ad71ca654c312fdec59194e393411fce0"><div class="ttname"><a href="classPort.html#ad71ca654c312fdec59194e393411fce0">Port::state</a></div><div class="ttdeci">PORT_STATE state</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00067">Port.hpp:67</a></div></div>
<div class="ttc" id="classPort_html_ad7ef0d65cab5721a7e2d9b2a71663eef"><div class="ttname"><a href="classPort.html#ad7ef0d65cab5721a7e2d9b2a71663eef">Port::pinType</a></div><div class="ttdeci">PIN_TYPE pinType</div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00065">Port.hpp:65</a></div></div>
<div class="ttc" id="classPort_html_a2cfb70a4b6d730e715042d646ec1d960"><div class="ttname"><a href="classPort.html#a2cfb70a4b6d730e715042d646ec1d960">Port::Port</a></div><div class="ttdeci">Port()</div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00049">Port.cpp:49</a></div></div>
<div class="ttc" id="Accessories_8h_html"><div class="ttname"><a href="Accessories_8h.html">Accessories.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>Port.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
